/****
* Fichero 1STCLASS.CH
* Include para las definiciones de clases
*
* (c) 1993-1994 Grupo EIDOS
*
* Versin: 1.1
*
* Antonio Rojo
*/


// ----------------------------------------------------------------------------
#ifndef _1STCLASS_CH
#define _1STCLASS_CH
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
#define VT_DEFAULT      0
#define VT_PUBLIC       1
#define VT_PROTECTED    2
#define VT_PRIVATE      3
#define VT_STATIC       4
// ----------------------------------------------------------------------------
#define ADD_VAR         1
#define ADD_METHOD      2
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
#include "1stNew.ch"
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
#xcommand ;
   _CLASS <class> [FROM <parent>] ;
=> ;
   FUNCTION <class>( lParent ) ;;
      STATIC nHandle, nParent ;;
      if lParent != nil ;;
         RETURN nParent ;;
      end ;;
      if nHandle == nil ;;
         nParent := FcNew( <(class)>, [<parent>()] ) ;;
         \#define _PARENT_ <class>( .t. )

#xcommand ;
   CLASS <class> [<from: INHERIT FROM, FROM, OF> <parent>] ;
=> ;
   _CLASS <class> [FROM <parent>]

#xcommand CREATE CLASS <*def*> => CLASS <def>
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
#xcommand ;
   VAR <var1> [,<varN>] [TYPE <tipo>] <type: PUBLIC, EXPORT, EXPORTED, VISIBLE> <stc: STATIC> ;
=> ;
   FcDMAdd( ADD_VAR, { <(var1)>, VT_PUBLIC, .t. } ) ;
   [; FcDMAdd( ADD_VAR, { <(varN)>, VT_PUBLIC, .t. } ) ]

#xcommand ;
   VAR <var1> [,<varN>] [TYPE <tipo>] <type: PUBLIC, EXPORT, EXPORTED, VISIBLE> ;
=> ;
   FcDMAdd( ADD_VAR, { <(var1)>, VT_PUBLIC, .f. } ) ;
   [; FcDMAdd( ADD_VAR, { <(varN)>, VT_PUBLIC, .f. } ) ]

#xcommand ;
   VAR <var1> [,<varN>] [TYPE <tipo>] <type: PROTEC, PROTECTED, READONLY, RO, NOASSIGN> <stc: STATIC> ;
=> ;
   FcDMAdd( ADD_VAR, { <(var1)>, VT_PROTECTED, .t. } ) ;
   [; FcDMAdd( ADD_VAR, { <(varN)>, VT_PROTECTED, .t. } ) ]

#xcommand ;
   VAR <var1> [,<varN>] [TYPE <tipo>] <type: PROTEC, PROTECTED, READONLY, RO, NOASSIGN> ;
=> ;
   FcDMAdd( ADD_VAR, { <(var1)>, VT_PROTECTED, .f. } ) ;
   [; FcDMAdd( ADD_VAR, { <(varN)>, VT_PROTECTED, .f. } ) ]

#xcommand ;
   VAR <var1> [,<varN>] [TYPE <tipo>] <type: PRIVATE, HIDDEN, LOCAL> <stc: STATIC> ;
=> ;
   FcDMAdd( ADD_VAR, { <(var1)>, VT_PRIVATE, .t. } ) ;
   [; FcDMAdd( ADD_VAR, { <(varN)>, VT_PRIVATE, .t. } ) ]

#xcommand ;
   VAR <var1> [,<varN>] [TYPE <tipo>] <type: PRIVATE, HIDDEN, LOCAL> ;
=> ;
   FcDMAdd( ADD_VAR, { <(var1)>, VT_PRIVATE, .f. } ) ;
   [; FcDMAdd( ADD_VAR, { <(varN)>, VT_PRIVATE, .f. } ) ]

#xcommand ;
   VAR <var1> [,<varN>] [TYPE <tipo>] <type: STATIC> ;
=> ;
   FcDMAdd( ADD_VAR, { <(var1)>, VT_DEFAULT, .t. } ) ;
   [; FcDMAdd( ADD_VAR, { <(varN)>, VT_DEFAULT, .t. } ) ]

#xcommand ;
   VAR <var1> [,<varN>] [TYPE <tipo>] ;
=> ;
   FcDMAdd( ADD_VAR, { <(var1)>, VT_DEFAULT, .f. } ) ;
   [; FcDMAdd( ADD_VAR, { <(varN)>, VT_DEFAULT, .f. } ) ]

#xcommand ;
   VAR <var> SETGET <Function> ;
=> ;
   FcDMAdd( ADD_METHOD, { <(var)>, {||<Function>()} } ) ;;
   FcDMAdd( ADD_METHOD, { '_'+<(var)>, {||<Function>()} } )

#xcommand DATA <*def*> => VAR <def>
#xcommand CLASS VAR <*def*> => VAR <def>
#xcommand CLASSVAR <*def*> => VAR <def>
#xcommand INSTVAR <*def*> => VAR <def>

#xcommand PUBLIC: => FcSetVar( VT_PUBLIC )
#xcommand EXPORT: => PUBLIC:
#xcommand EXPORTED: => PUBLIC:
#xcommand VISIBLE: => PUBLIC:

#xcommand PROTECTED: => FcSetVar( VT_PROTECTED )
#xcommand READONLY: => PROTECTED:
#xcommand PROTEC: => PROTECTED:

#xcommand PRIVATE: => FcSetVar( VT_PRIVATE )
#xcommand HIDDEN: => PRIVATE:
#xcommand LOCAL: => PRIVATE:
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
#xcommand ;
   MESSAGE <message> <ctor: CONSTRUCTOR, CTOR> ;
=> ;
   FcDMAdd( ADD_METHOD, { "New", {||<message>()} } )

#xcommand ;
   MESSAGE <message1> METHOD <method1> [,<messageN> METHOD <methodN>] ;
=> ;
   FcDMAdd( ADD_METHOD, { <(message1)>, {||<method1>()} } ) ;
   [; FcDMAdd( ADD_METHOD, { <(messageN)>, {||<methodN>()} } ) ]

#xcommand ;
   MESSAGE <message1> [, <messageN> ] ;
=> ;
   FcDMAdd( ADD_METHOD, { <(message1)>, {||<message1>()} } ) ;
   [; FcDMAdd( ADD_METHOD, { <(messageN)>, {||<messageN>()} } ) ]

#xcommand ;
   MESSAGE <message1> = <method1> [,<messageN> = <methodN>] ;
=> ;
   FcDMAdd( ADD_METHOD, { <(message1)>, {||<method1>()} } ) ;
   [; FcDMAdd( ADD_METHOD, { <(messageN)>, {||<methodN>()} } ) ]

#xcommand ;
   MESSAGE <message>([<pars,...>]) <ctor: CONSTRUCTOR, CTOR> ;
=> ;
   FcDMAdd( ADD_METHOD, { "New", {||<message>()} } )

#xcommand ;
   MESSAGE <message1> METHOD <method1>([<pars1,...>]) [,<messageN> METHOD <methodN>([<pars2,...>]) ] ;
=> ;
   FcDMAdd( ADD_METHOD, { <(message1)>, {||<method1>()} } ) ;
   [; FcDMAdd( ADD_METHOD, { <(messageN)>, {||<methodN>()} } ) ]

#xcommand ;
   MESSAGE <message1> [,<messageN>] <virt: VIRTUAL, ISNULL> ;
=> ;
   FcDMAdd( ADD_METHOD, { <(message1)>, {||_pFcVirtual()} } ) ;
   [; FcDMAdd( ADD_METHOD, { <(messageN)>, {||_pFcVirtual()} } ) ]

#xcommand ;
   MESSAGE <message1>([<pars1,...>]) [, <messageN>([<pars2,...>]) ] ;
=> ;
   FcDMAdd( ADD_METHOD, { <(message1)>, {||<message1>()} } ) ;
   [; FcDMAdd( ADD_METHOD, { <(messageN)>, {||<messageN>()} } ) ]

#xcommand ;
   MESSAGE <message1> = <method1>([<pars1,...>]) [,<messageN> = <methodN>([<pars2,...>])] ;
=> ;
   FcDMAdd( ADD_METHOD, { <(message1)>, {||<method1>()} } ) ;
   [; FcDMAdd( ADD_METHOD, { <(messageN)>, {||<methodN>()} } ) ]

#xcommand ;
   CONSTRUCTOR <message> ;
=> ;
   MESSAGE <message> CONSTRUCTOR

#xtranslate CLASS MESSAGE <*def*> => MESSAGE <def>
#xtranslate CLASS METHOD <*def*> => MESSAGE <def>
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
#xcommand ;
   ENDCLASS ;
=> ;
         nHandle = FcCreate() ;;
      end ;;
   RETURN __ClassIns( nHandle ) ;;
   #include "1stEnd.ch"

#xcommand END CLASS => ENDCLASS
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
#xtranslate @:<message>([<pars,...>]) => Self:<message>([<pars>])
#xtranslate :: => Self:
#xtranslate This => Self
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
#xcommand ;
   _METHOD [<fun:PROCEDURE,FUNCTION>] <method> [<friend:PUBLIC,FRIEND>] [CLASS <class>] ;
=> ;
   FUNCTION <method>() ;;
      LOCAL Self := QSelf()

#xcommand ;
   _METHOD [<fun:PROCEDURE,FUNCTION>] <method> [CLASS <class>] ;
=> ;
   STATIC FUNCTION <method>() ;;
      LOCAL Self := QSelf()

#xcommand ;
   _METHOD [<fun:PROCEDURE,FUNCTION>] <method>([<pars,...>]), <mthsup>([<psup,...>]) [CLASS <class>] ;
=> ;
   STATIC FUNCTION <method>( [<pars>] ) ;;
      STATIC _mFcSuper ;;
      LOCAL Self := QSelf() ;;
      LOCAL exParent := QParent( _mFcSuper ):<mthsup>( [<psup>] )

#xcommand ;
   _METHOD [<fun:PROCEDURE,FUNCTION>] <method>([<pars,...>]), ([<psup,...>]) [CLASS <class>] ;
=> ;
   STATIC FUNCTION <method>( [<pars>] ) ;;
      STATIC _mFcSuper ;;
      LOCAL Self := QSelf() ;;
      LOCAL exParent := QParent( _mFcSuper ):<method>( [<psup>] )

#xcommand ;
   _METHOD [<fun:PROCEDURE,FUNCTION>] <method>([<pars,...>]) [<friend:PUBLIC,FRIEND>] [CLASS <class>] ;
=> ;
   FUNCTION <method>( [<pars>] ) ;;
      LOCAL Self := QSelf()

#xcommand ;
   _METHOD [<fun:PROCEDURE,FUNCTION>] <method>([<pars,...>]) [CLASS <class>] ;
=> ;
   STATIC FUNCTION <method>( [<pars>] ) ;;
      LOCAL Self := QSelf()
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
#xtranslate ;
   Parent:<message> ;
=> ;
   FcParent( <(message)>, _PARENT_ )

#xtranslate ;
   QParent(<var>):<message> ;
=> ;
   FcParentE( if( <var> = nil, <var> := FcParentP( <(message)>, _PARENT_ ), <var> ) )

#xtranslate ;
   Parent:<message>( [<pars,...>] ) ;
=> ;
   FcParent( [<pars>,] <(message)>, _PARENT_ )

#xtranslate ;
   QParent(<var>):<message>( [<pars,...>] ) ;
=> ;
   FcParentE( [<pars>,] if( <var> = nil, <var> := FcParentP( <(message)>, _PARENT_ ), <var> ) )

#xtranslate Super: => Parent:
#xtranslate QSuper( => QParent(
#xtranslate Self:FcParent => FcParent
#xtranslate Self:FcParentE => FcParentE
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
#command ;
   INITIALIZE CLASS ;
=> ;
   #include "1stNew.ch"
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
#endif
// ----------------------------------------------------------------------------
