/****
* Fichero FcDemo.prg
* Demo de FirstClass
*
* (c) 1993 Grupo EIDOS
*
* Helio Yago
* Alfonso Fraguas
*/
//
#include "Var1st.CH"
#include "InKey.CH"

//
#define CLR_ALERT    "W/B+"

//
STATIC aScope

//
FUNCTION Start()
   LOCAL oMenu

   InitVar()
   OBOX:Save()

   SetCursor( 0 )
   SetBlink( .F. )

   SET DATE ITALIAN

   oMenu := InitMenu()
   oMenu:bExit := { | |Alert( "Abandonar la aplicacin", ;
                  { "S", "No" }, CLR_ALERT ) == 1 }

   SET COLOR TO COLOR_GROUND
   CLS
   OBOX:Display( 0, 0, 0, 79, "", COLOR_SAY )
   @ 0, 0 SAY " First Class              "            + ;
             "Programa de Demostracin              " + ;
             "(c) Grupo Eidos"                          ;
         COLOR COLOR_SAY_L
   CreaWAreas()
   OpenWAreas()

   OBOX:Display( 1, 0, 1, 79, "", COLOR_MENU )

   oMenu:Execute()

   OBOX:CloseAll()

RETURN NIL

// Variables seudo-pblicas
FUNCTION Var1St()
   STATIC aVar := {,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,}
RETURN aVar

//
FUNCTION InitVar()
   COLOR_GROUND  := "W/N"
   COLOR_BOX     := "W/B"
   COLOR_MENU    := "W+/B"
   COLOR_PROMPT  := "W+/N"
   COLOR_ACTIVE  := "GR+/B"
   COLOR_MESSAGE := "B/W"
   COLOR_LOGO    := "BG+/BG"
   COLOR_SAY     := "W+/BG"
   COLOR_SAY_L   := "GR+/BG"
   COLOR_GET     := "B/BG, GR+/B"
   COLOR_GET_1   := "R/W"
   COLOR_TEXT    := "W+/BG"

   BOX_SOLID     := " "
   BOX_1         := "ķԳ õ"

   /*
      Para agilizar las llamadas posteriores...
      Inicializamos las clases llamando a sus funciones creadoras.
   */
   FcBox()
   FcBoxTit()
   FcCalc()
   FcMenu()
   FcPrompt()
   FcBrowse()
   FcEdit()
   FcGet()
   FcScope()
   FcWorkArea()

   OBOX          := FcBox():New()
   OBOX_T        := FcBoxTit():New()

   WORKAREAS     := {}

   SET SCOREBOARD OFF

RETURN NIL

//
FUNCTION InitMenu()
   /* OBJETO MENU */
   LOCAL oMenu := FcCreateMenu( 1, 2, .F. )

   /* PUNTEROS A CABECERAS DE COLUMNA */
   LOCAL hCol1 := FcAppendCol( oMenu, "Ficheros "   ,, .T. )
   LOCAL hCol2 := FcAppendCol( oMenu, "Calculadora ",, .T. )
   LOCAL hCol3 := FcAppendCol( oMenu, "Areas "      ,, .T. )
   LOCAL hCol4 := FcAppendCol( oMenu, "Abrir "      ,, .T. )
   LOCAL hCol5 := FcAppendCol( oMenu, "Cerrar "     ,, .T. )
   LOCAL hCol6 := FcAppendCol( oMenu, "Acerca de...",, .T. )


   /* PROMPTS DE COLUMNA 1 */
   FcAppendMenu( hCol1, "Browse "             ,, { || Browse()      } )
   FcAppendMenu( hCol1, "Ambito"              ,, { || Scope()       } )
   FcAppendMenu( hCol1, "Editor Simple"       ,, { || Edit()        } )
   FcAppendMenu( hCol1, "Editor "             ,, { || Editor()      } )
   FcAppendMenu( hCol1, "Ver Herencia"        ,, { || FcBrowInher() } )
   FcAppendMenu( hCol1, "Estado de la Memoria",, { || Mem()         } )

   /* PROMPTS DE COLUMNA 2 */
   FcAppendMenu( hCol2, "Abrir"           ,, { || CalcOpen()  } )
   FcAppendMenu( hCol2, "Dejar Residente" ,, { || CalcRes()   } )
   FcAppendMenu( hCol2, "Quitar Residente",, { || CalcNoRes() } )

   /* PROMPTS DE COLUMNA 3 */
   FcAppendMenu( hCol3, "Abrir Todo"   ,, { || OpenWAreas()  } )
   FcAppendMenu( hCol3, "Cerrar Todo"  ,, { || CloseWAreas() } )
   FcAppendMenu( hCol3, "Ver Estado"   ,, { || ViewWAreas()  } )
   FcAppendMenu( hCol3, "Crear indices",, { || IndexWAreas() } )

   /* PROMPTS DE COLUMNA 4 */
   FcAppendMenu( hCol4, "Area ^1 ",, { || ActivArea( 1 ) } )
   FcAppendMenu( hCol4, "Area ^2 ",, { || ActivArea( 2 ) } )
   FcAppendMenu( hCol4, "Area ^3 ",, { || ActivArea( 3 ) } )


   /* PROMPTS DE COLUMNA 5 */
   FcAppendMenu( hCol5, "Area ^1 ",, { || InActivArea( 1 ) } )
   FcAppendMenu( hCol5, "Area ^2 ",, { || InActivArea( 2 ) } )
   FcAppendMenu( hCol5, "Area ^3 ",, { || InActivArea( 3 ) } )


   /* PROMPTS DE COLUMNA 6 */
   FcAppendMenu( hCol6, "First^Class ", "... FirstClass" , { || Abt1St()   } )
   FcAppendMenu( hCol6, "Eidos "      , "... Grupo Eidos", { || AbtEidos() } )

RETURN oMenu

//
FUNCTION OneGet(nRow,nCol,xVar,cPict,cColor,bWhen,bValid)
   LOCAL oGet
   LOCAL xReturn   := xVar

   oGet := GetNew( nRow,nCol,{|x| If(PCount() == 0, xVar, xVar := x)}, ;
                   "ONEGET",cPict,cColor)
   oGet:PreBlock  := bWhen
   oGet:PostBlock := bValid
   ReadModal( { oGet } )
RETURN If( LastKey() == K_ESC , xReturn , xVar )

//
FUNCTION GetBlock( nField )
RETURN FieldBlock( FieldName( nField ) )

//
FUNCTION Mem()
   OBOX:Display( 16 , 45 , 23 , 78 , BOX_SOLID , COLOR_LOGO )
   @ 17, 47 SAY "Estado de la Memoria"  ;
            COLOR COLOR_SAY
   @ 19, 47 SAY "Convencional: " + PadL( Memory(0), 5, '0' ) COLOR COLOR_SAY
   @ 20, 47 SAY "Caracteres  : " + PadL( Memory(1), 5, '0' ) COLOR COLOR_SAY
   @ 21, 47 SAY "Para RUN    : " + PadL( Memory(2), 5, '0' ) COLOR COLOR_SAY
   InKey(0)
   OBOX:Close()
RETURN NIL

//
FUNCTION Abt1St()
   OBOX:Display( 16, 45, 23, 78, BOX_SOLID, COLOR_LOGO )
   @ 17, 47 SAY "FIRSTCLASS. (c) Grupo EIDOS"    COLOR COLOR_SAY
   @ 19, 47 SAY "Es un producto desarrollado"    COLOR COLOR_SAY
   @ 20, 47 SAY "por EXCALIBUR para GRUPO EIDOS" COLOR COLOR_SAY
   InKey(0)
   OBOX:Close()
RETURN NIL

//
FUNCTION AbtEidos()
   OBOX:Display( 16, 45, 23, 78, BOX_SOLID, COLOR_LOGO )
   @ 17, 47 SAY "Grupo EIDOS"                  COLOR COLOR_SAY
   @ 19, 47 SAY "Consultora y documentacin " COLOR COLOR_SAY
   @ 20, 47 SAY "Informtica , S.L. "          COLOR COLOR_SAY
   @ 21, 47 SAY "C/ Gavia seca, 2 - 1"        COLOR COLOR_SAY
   @ 22, 47 SAY "28031-MADRID"                 COLOR COLOR_SAY
   InKey(0)
   OBOX:Close()
RETURN NIL

//
FUNCTION OpenDbf()

   LOCAL cFile  := "Test.dbf"

   IF !File( cFile )
      Alert( "" + cFile + " no existe ! ",, CLR_ALERT )
      RETURN NIL
   END IF

   IF !File( "First.ntx" )
      Alert( "FIRST.NTX no existe ;;" + ;
             " Debe crear los ndices ! ;" + ;
             " Use la opcin Abrir Area del men reas ",, CLR_ALERT )
      RETURN NIL
   END IF

RETURN NIL

//
FUNCTION CreaWAreas()

   LOCAL aIndex1 := { "Apell1"  , "Nomb1" , "Eda1" },  ;
         aIndex2 := { "Apell2"  , "Nomb2" , "Eda2" },  ;
         aIndex3 := { "Apell3"  , "Nomb3" , "Eda3" },  ;
         aIndKey := { "Apellido", "Nombre", "Edad" }


   IF Empty( WORKAREAS )
      aAdd( WORKAREAS, FcWorkArea():New("Test",,"Area1",,.T.,,aIndex1,aIndKey))
      aAdd( WORKAREAS, FcWorkArea():New("Test",,"Area2",,.T.,,aIndex2,aIndKey))
      aAdd( WORKAREAS, FcWorkArea():New("Test",,"Area3",,.T.,,aIndex3,aIndKey))

      aEval( WORKAREAS, { |x,y|  x:nArea:= y      , ;
                                 x:Open()         , ;
                                .x:DbSetOrder( y ), ;
                                .x:DbGoTop()  } )

      CloseWAreas()
   END IF

RETURN NIL

//
FUNCTION OpenWAreas()
   IF Empty( WORKAREAS )
      ErrWAreas()
      RETURN NIL
   END IF
   aEval( WORKAREAS, { |x| x:Open() } )
RETURN NIL

//
FUNCTION CloseWAreas()
   IF Empty( WORKAREAS )
      ErrWAreas()
      RETURN NIL
   END IF
   aEval( WORKAREAS, { |x| x:Close() } )
RETURN NIL

//
FUNCTION ViewWAreas()
   IF Empty( WORKAREAS )
      ErrWAreas()
      RETURN NIL
   END IF

   DispAreas( 01, 1 )
   DispAreas( 28, 2 )
   DispAreas( 56, 3 )

   InKey(0)

   OBOX:Close()
   OBOX:Close()
   OBOX:Close()
RETURN NIL

//
FUNCTION ActivArea( nArea )
   IF Empty( WORKAREAS )
      ErrWAreas()
      RETURN NIL
   END IF

   WORKAREAS[ nArea ]:Open()
   dbSelectArea( nArea )
RETURN NIL

//
FUNCTION InActivArea( nArea )
   IF Empty( WORKAREAS )
      ErrWAreas()
      RETURN NIL
   END IF

   WORKAREAS[ nARea ]:Close()
RETURN NIL

//
FUNCTION IndexWArea()
   IF Empty( WORKAREAS )
      ErrWAreas()
      RETURN NIL
   END IF

   aEval( WORKAREAS, { |x| x:Open(), x:Index(), x:Open() } )
RETURN NIL

//
STATIC FUNCTION DispAreas( nCol, nArea )

   OBOX:Display( 15, nCol-1, 23, nCol+22, BOX_SOLID, COLOR_LOGO )

   @ 16, nCol SAY " Area.....: " COLOR COLOR_SAY
   @ 17, nCol SAY " Nombre...: " COLOR COLOR_SAY
   @ 18, nCol SAY " Alias....: " COLOR COLOR_SAY
   @ 19, nCol SAY " RecNo()..: " COLOR COLOR_SAY
   @ 20, nCol SAY " Abierta..: " COLOR COLOR_SAY
   @ 21, nCol SAY " Borrado..: " COLOR COLOR_SAY
   @ 22, nCol SAY " Bloqueado: " COLOR COLOR_SAY

   @ 16, nCol + 12 SAY Str( WORKAREAS[ nArea ]:nArea, 3 ) COLOR COLOR_SAY_L
   @ 17, nCol + 12 SAY      WORKAREAS[ nArea ]:cDbf       COLOR COLOR_SAY_L
   @ 18, nCol + 12 SAY      WORKAREAS[ nArea ]:cAlias     COLOR COLOR_SAY_L
   @ 19, nCol + 12 SAY Str( WORKAREAS[ nArea ]:nRecNo )   COLOR COLOR_SAY_L
   @ 20, nCol + 12 SAY     .WORKAREAS[ nArea ]:Used()     COLOR COLOR_SAY_L
   @ 21, nCol + 12 SAY      WORKAREAS[ nArea ]:lDeleted   COLOR COLOR_SAY_L
   @ 22, nCol + 12 SAY      WORKAREAS[ nArea ]:lFlock     COLOR COLOR_SAY_L

RETURN NIL

//
STATIC FUNCTION ErrWAreas()
   Alert( "Los objetos WorkAreas han de ser creados ; " + ;
          "Antes de abrirlos o cerrarlos ",, CLR_ALERT )
RETURN NIL

//
FUNCTION Browse()
   LOCAL oBrowse

   IF !Used()
      Alert( "No hay Areas de trabajo en uso;" + ;
             "Por favor, abra una",, CLR_ALERT )
      RETURN NIL
   END IF

   @ MaxRow(), 1 SAY "Alt+S Buscar, " + ;
                     "Alt+R Especificar Rango, " + ;
                     "Alt+I Ordenar por Columna" COLOR COLOR_MESSAGE

   dbGoTop()
   oBrowse := FCBrowse():Create( 2, 12, 23, 78 )
   oBrowse:aScope  := aScope
   oBrowse:aKeys   := { K_ALT_R, K_ALT_I }
   oBrowse:CreateColumns()
   oBrowse:GetColumn(09):Picture := "99"
   oBrowse:GetColumn(10):Picture := "999,999"
   oBrowse:aBlocks := { { |x| SetScope( x ) }, { |x| BrowIndex( x ) } }

   oBrowse:Execute()

RETURN NIL

//
FUNCTION SetScope( oBrowse )
   LOCAL nRecNo := RecNo()
   LOCAL aScope := FcScope():NewExecute( 20, 12 )

   IF LastKey() == K_ESC
      dbGoto( nRecNo )
      RETURN .F.
   END IF
   oBrowse:aScope := aScope
   oBrowse:FixScope()
   oBrowse:RefreshAll()
RETURN .T.

//
FUNCTION BrowIndex( oBrowse )
   LOCAL nRecNo := RecNo()
   LOCAL cField := oBrowse:GetColumn( oBrowse:ColPos ):Heading
   LOCAL cLine  := SaveScreen( MaxRow(), 1, MaxRow(), MaxCol() - 1 )

   IF FieldPos( cField ) > 0
      @ MaxRow(), 1 SAY PadR( "Creando indice Temporal", MaxCol() - 1 ) ;
                    COLOR COLOR_MESSAGE
      dbCreateIndex( "TMP", cField, &("{||"+cField+"}") )
      @ MaxRow(), 1 SAY Space( MaxCol() - 1 ) ;
                    COLOR COLOR_MESSAGE
      RestScreen( MaxRow(), 1, MaxRow(), MaxCol() - 1, cLine )
   END IF
   dbGoTo( nRecNo )
   oBrowse:RefreshAll()
RETURN .T.

//
FUNCTION Scope()
LOCAL oScope

   IF !Used()
      Alert( "No hay Areas de trabajo en uso;" + ;
             "Por favor, abra una",, CLR_ALERT )
      RETURN .F.
   END IF

   oScope := FcScope():New( 20, 01 )
   oScope:Execute()

RETURN .T.

//
FUNCTION CalcOpen()
   LOCAL oCalc := FcCalc():New()
   oCalc:Display()
RETURN NIL

//
FUNCTION CalcRes()
   OCALC := FcCalc():New()
   @ MaxRow(), 1 SAY "La Calculadora esta residente, llamela con F3" ;
                 COLOR COLOR_MESSAGE
   SetKey( K_F3, { |w, x, y, z| OCALC:Display( , , z) } )
   InKey( .5 )
   @ MaxRow(), 1 SAY Space( MaxCol() - 1 ) COLOR COLOR_MESSAGE
RETURN NIL

//
FUNCTION CalcNoRes()
   OCALC := NIL
   @ MaxRow(), 1 SAY "La Calculadora ha dejado de estar residente" ;
                 COLOR COLOR_MESSAGE
   SetKey( K_F3, { || NIL } )
   InKey( .5 )
   @ MaxRow(), 1 SAY Space( MaxCol() - 1 ) COLOR COLOR_MESSAGE
RETURN NIL

//
FUNCTION Edit()

   LOCAL GetList := {}, ;
         nCount       , ;
         lUpdate

   aEval( WORKAREAS, {|x|x:Open()} )

   OBOX_T:Display( 08, 01, 19, 46, BOX_1, COLOR_SAY, "Editor Simple", 3 )

   @ 09, 02 SAY " Apellido.: " COLOR COLOR_TEXT
   @ 10, 02 SAY " Nombre...: " COLOR COLOR_TEXT
   @ 11, 02 SAY " Calle....: " COLOR COLOR_TEXT
   @ 12, 02 SAY " Ciudad...: " COLOR COLOR_TEXT
   @ 13, 02 SAY " Estado...: " COLOR COLOR_TEXT
   @ 14, 02 SAY " C.P......: " COLOR COLOR_TEXT
   @ 15, 02 SAY " F.Contra.: " COLOR COLOR_TEXT
   @ 16, 02 SAY " Casado/a.: " COLOR COLOR_TEXT
   @ 17, 02 SAY " Edad.....: " COLOR COLOR_TEXT
   @ 18, 02 SAY " Salario..: " COLOR COLOR_TEXT

   FOR nCount := 1 TO 10
      aAdd( GetList, FcGet():New( nCount + 8, 15     ,  ;
                                  GetBlock( nCount ) ,  ;
                                  FieldName( nCount ),, ;
                                  COLOR_GET ) )
   NEXT nCount

   GetList[ 09 ]:Picture := "99"
   GetList[ 10 ]:Picture := "999,999"

   WHILE .T.
      aEval( GetList, { | x | x:Display() } )

      RecLock( 0 )

      ReadModal( GetList )

      IF LastKey() == K_ESC
         EXIT
      END IF

      lUpdate := ( Alert( "Actualizar", { "S", "No" }, CLR_ALERT ) == 1 )

      aEval( GetList, { | x | x:Update( lUpdate ) } )

   END WHILE

   OBOX_T:Close()

RETURN NIL

//
FUNCTION Editor()
   LOCAL bScr  := { || EditScreen() }
   LOCAL aRows := { 03, 04, 05, 06, 07, 08, 09, 10, 11, 12 }
   LOCAL aCols := { 31, 31, 31, 31, 31, 31, 31, 31, 31, 31 }
   LOCAL aPict := { , , , , , , , , "99", "999,999" }
   LOCAL oEdit := FcEdit():New( bScr, "Area1", 1 ,,,, aRows, aCols, , aPict )

   oEdit:aIndexMenu   := { "Apellidos ", "Nombre ", ;
                           "Edad " }
   oEdit:aIndexFields := { 1, 2, 9 }
   oEdit:cMemoName    := "TEXT"
   oEdit:aMenuMore    := { { " Extra !!... ", "Opcin Extra." } }
   oEdit:aBlocksMore  := { {|| Alert( " Hola, Soy una opcin extra !! ",,;
                               CLR_ALERT ) } }

   OBOX:Save( 0, 0, MaxRow(), MaxCol() )
   oEdit:Standard()
   OBOX:Close()
RETURN NIL

//
FUNCTION EditScreen()
   DispBox( 02, 17, 13, 62, BOX_1, COLOR_SAY )
   DispBox( 02, 63, 21, 79, BOX_1, COLOR_SAY )
   @ 06, 63 SAY "Ķ" ;
            COLOR COLOR_SAY

   @ 03, 18 SAY " Apellido.: " COLOR COLOR_TEXT
   @ 04, 18 SAY " Nombre...: " COLOR COLOR_TEXT
   @ 05, 18 SAY " Calle....: " COLOR COLOR_TEXT
   @ 06, 18 SAY " Ciudad...: " COLOR COLOR_TEXT
   @ 07, 18 SAY " Estado...: " COLOR COLOR_TEXT
   @ 08, 18 SAY " C.P......: " COLOR COLOR_TEXT
   @ 09, 18 SAY " F.Contra.: " COLOR COLOR_TEXT
   @ 10, 18 SAY " Casado/a.: " COLOR COLOR_TEXT
   @ 11, 18 SAY " Edad.....: " COLOR COLOR_TEXT
   @ 12, 18 SAY " Salario..: " COLOR COLOR_TEXT
RETURN NIL